﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Shapes;
using System.Windows.Media;

namespace VisualLinq
{
    public abstract class VisualDoubleChild<T> : VisualChild<T>
    {
        Line rightLine;

        protected VisualDoubleChild(IVisualEnumerable topParent, IVisualEnumerable rightParent, string text)
            : base(topParent, text)
        {
            rightLine = new Line();
            rightLine.Y1 = Canvas.GetLeft(topParent.Box) + topParent.Box.Height / 2;
            rightLine.X1 = Canvas.GetLeft(topParent.Box);
            rightLine.Y2 = Canvas.GetTop(Box) + Box.Height / 2;
            rightLine.X2 = Canvas.GetLeft(Box) + Box.Width;
            rightLine.Stroke = Brushes.Black;
            this.Canvas.Children.Add(rightLine);
        }

        internal override void ThreadedDispose()
        {
            base.ThreadedDispose();
            Canvas.Children.Remove(rightLine);
        }
    }
}
